﻿using System;
using System.Collections.ObjectModel;
using System.Threading.Tasks;
using Xamarin.Forms;
namespace Chart_GettingStarted
{
    public class ViewModel
    {
        private bool canStopTimer;
        private int count;

        Random random = new Random();

        public ObservableCollection<ChartDataModel> LiveData { get; set; }

        public ViewModel()
        {
            LiveData = new ObservableCollection<ChartDataModel>();
            UpdateLiveData();
        }


        public async void UpdateLiveData()
        {
            for (var i = 0; i < 1000; i++)
            {
                LiveData.Add(new ChartDataModel(i, random.Next(10, 30)));
                count++;
            }

            count = LiveData.Count;

            await Task.Delay(200);

        }

        private bool UpdateData()
        {
            if (canStopTimer) return false;

            LiveData.Add(new ChartDataModel(count, random.Next(10, 30)));

            count++;

            return true;
        }

        public void StopTimer()
        {
            canStopTimer = true;
        }

        public void StartTimer()
        {
            Device.StartTimer(new TimeSpan(0, 0, 0, 0, 10), UpdateData);

            canStopTimer = false;
        }

    }

    public class ChartDataModel
    {
        public double XValue { get; set; }
        public double YValue { get; set; }
        public ChartDataModel(double xvalue, double yvalue)
        {
            XValue = xvalue;
            YValue = yvalue;
        }
    }
}